/**
 * **This module is experimental**
 *
 * Experimental features are published in order to get early feedback from the community.
 *
 * A feature tagged as _Experimental_ is in a high state of flux, you're at risk of it changing without notice.
 *
 * @since 2.3.0
 */
import { Option } from 'fp-ts/es6/Option'
import { At } from './At'
import { Iso } from './Iso'
import { Optional } from './Optional'
/**
 * @category model
 * @since 2.3.0
 */
export interface Index<S, I, A> {
  readonly index: (i: I) => Optional<S, A>
}
/**
 * @category constructors
 * @since 2.3.0
 */
export declare const fromAt: <T, J, B>(at: At<T, J, Option<B>>) => Index<T, J, B>
/**
 * Lift an instance of `Index` using an `Iso`
 *
 * @category constructors
 * @since 2.3.0
 */
export declare const fromIso: <T, S>(iso: Iso<T, S>) => <I, A>(sia: Index<S, I, A>) => Index<T, I, A>
/**
 * @category constructors
 * @since 2.3.2
 */
export declare const indexArray: <A = never>() => Index<ReadonlyArray<A>, number, A>
/**
 * @category constructors
 * @since 2.3.2
 */
export declare const indexRecord: <A = never>() => Index<Readonly<Record<string, A>>, string, A>
