import { pipe } from 'fp-ts/es6/pipeable';
import * as _ from './internal';
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 2.3.0
 */
export var fromAt = function (at) { return ({
    index: function (i) { return _.lensComposePrism(_.prismSome())(at.at(i)); }
}); };
/**
 * Lift an instance of `Index` using an `Iso`
 *
 * @category constructors
 * @since 2.3.0
 */
export var fromIso = function (iso) { return function (sia) { return ({
    index: function (i) { return pipe(iso, _.isoAsOptional, _.optionalComposeOptional(sia.index(i))); }
}); }; };
/**
 * @category constructors
 * @since 2.3.2
 */
export var indexArray = _.indexArray;
/**
 * @category constructors
 * @since 2.3.2
 */
export var indexRecord = _.indexRecord;
