"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.indexRecord = exports.indexArray = exports.fromIso = exports.fromAt = void 0;
var pipeable_1 = require("fp-ts/lib/pipeable");
var _ = require("./internal");
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 2.3.0
 */
var fromAt = function (at) { return ({
    index: function (i) { return _.lensComposePrism(_.prismSome())(at.at(i)); }
}); };
exports.fromAt = fromAt;
/**
 * Lift an instance of `Index` using an `Iso`
 *
 * @category constructors
 * @since 2.3.0
 */
var fromIso = function (iso) { return function (sia) { return ({
    index: function (i) { return pipeable_1.pipe(iso, _.isoAsOptional, _.optionalComposeOptional(sia.index(i))); }
}); }; };
exports.fromIso = fromIso;
/**
 * @category constructors
 * @since 2.3.2
 */
exports.indexArray = _.indexArray;
/**
 * @category constructors
 * @since 2.3.2
 */
exports.indexRecord = _.indexRecord;
