"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.atRecord = exports.indexRecord = exports.indexArray = exports.fromTraversable = exports.traversalComposeTraversal = exports.findFirst = exports.optionalComposeOptional = exports.optionalModify = exports.optionalModifyOption = exports.optionalAsTraversal = exports.prismLeft = exports.prismRight = exports.prismSome = exports.prismFromPredicate = exports.prismFromNullable = exports.prismComposeLens = exports.prismSet = exports.prismModify = exports.prismModifyOption = exports.prismAsTraversal = exports.prismAsOptional = exports.lensComponent = exports.lensProps = exports.lensProp = exports.lensId = exports.lensComposePrism = exports.lensComposeLens = exports.lensAsTraversal = exports.lensAsOptional = exports.isoAsOptional = exports.isoAsLens = void 0;
var A = require("fp-ts/lib/Array"); // TODO: replace with ReadonlyArray in v3
var R = require("fp-ts/lib/Record"); // TODO: replace with ReadonlyRecord in v3
var function_1 = require("fp-ts/lib/function");
var O = require("fp-ts/lib/Option");
var E = require("fp-ts/lib/Either");
var pipeable_1 = require("fp-ts/lib/pipeable");
// -------------------------------------------------------------------------------------
// Iso
// -------------------------------------------------------------------------------------
/** @internal */
var isoAsLens = function (sa) { return ({
    get: sa.get,
    set: function_1.flow(sa.reverseGet, function_1.constant)
}); };
exports.isoAsLens = isoAsLens;
/** @internal */
var isoAsOptional = function (sa) { return ({
    getOption: function_1.flow(sa.get, O.some),
    set: function_1.flow(sa.reverseGet, function_1.constant)
}); };
exports.isoAsOptional = isoAsOptional;
// -------------------------------------------------------------------------------------
// Lens
// -------------------------------------------------------------------------------------
/** @internal */
var lensAsOptional = function (sa) { return ({
    getOption: function_1.flow(sa.get, O.some),
    set: sa.set
}); };
exports.lensAsOptional = lensAsOptional;
/** @internal */
var lensAsTraversal = function (sa) { return ({
    modifyF: function (F) { return function (f) { return function (s) { return F.map(f(sa.get(s)), function (a) { return sa.set(a)(s); }); }; }; }
}); };
exports.lensAsTraversal = lensAsTraversal;
/** @internal */
var lensComposeLens = function (ab) { return function (sa) { return ({
    get: function (s) { return ab.get(sa.get(s)); },
    set: function (b) { return function (s) { return sa.set(ab.set(b)(sa.get(s)))(s); }; }
}); }; };
exports.lensComposeLens = lensComposeLens;
/** @internal */
var lensComposePrism = function (ab) { return function (sa) {
    return exports.optionalComposeOptional(exports.prismAsOptional(ab))(exports.lensAsOptional(sa));
}; };
exports.lensComposePrism = lensComposePrism;
/** @internal */
var lensId = function () { return ({
    get: function_1.identity,
    set: function_1.constant
}); };
exports.lensId = lensId;
/** @internal */
var lensProp = function (prop) { return function (lens) { return ({
    get: function (s) { return lens.get(s)[prop]; },
    set: function (ap) { return function (s) {
        var _a;
        var oa = lens.get(s);
        if (ap === oa[prop]) {
            return s;
        }
        return lens.set(Object.assign({}, oa, (_a = {}, _a[prop] = ap, _a)))(s);
    }; }
}); }; };
exports.lensProp = lensProp;
/** @internal */
var lensProps = function () {
    var props = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        props[_i] = arguments[_i];
    }
    return function (lens) { return ({
        get: function (s) {
            var a = lens.get(s);
            var r = {};
            for (var _i = 0, props_1 = props; _i < props_1.length; _i++) {
                var k = props_1[_i];
                r[k] = a[k];
            }
            return r;
        },
        set: function (a) { return function (s) {
            var oa = lens.get(s);
            for (var _i = 0, props_2 = props; _i < props_2.length; _i++) {
                var k = props_2[_i];
                if (a[k] !== oa[k]) {
                    return lens.set(Object.assign({}, oa, a))(s);
                }
            }
            return s;
        }; }
    }); };
};
exports.lensProps = lensProps;
/** @internal */
var lensComponent = function (prop) { return function (lens) { return ({
    get: function (s) { return lens.get(s)[prop]; },
    set: function (ap) { return function (s) {
        var oa = lens.get(s);
        if (ap === oa[prop]) {
            return s;
        }
        var copy = oa.slice();
        copy[prop] = ap;
        return lens.set(copy)(s);
    }; }
}); }; };
exports.lensComponent = lensComponent;
// -------------------------------------------------------------------------------------
// Prism
// -------------------------------------------------------------------------------------
/** @internal */
var prismAsOptional = function (sa) { return ({
    getOption: sa.getOption,
    set: function (a) { return exports.prismSet(a)(sa); }
}); };
exports.prismAsOptional = prismAsOptional;
/** @internal */
var prismAsTraversal = function (sa) { return ({
    modifyF: function (F) { return function (f) { return function (s) {
        return pipeable_1.pipe(sa.getOption(s), O.fold(function () { return F.of(s); }, function (a) { return F.map(f(a), function (a) { return exports.prismSet(a)(sa)(s); }); }));
    }; }; }
}); };
exports.prismAsTraversal = prismAsTraversal;
/** @internal */
var prismModifyOption = function (f) { return function (sa) { return function (s) {
    return pipeable_1.pipe(sa.getOption(s), O.map(function (o) {
        var n = f(o);
        return n === o ? s : sa.reverseGet(n);
    }));
}; }; };
exports.prismModifyOption = prismModifyOption;
/** @internal */
var prismModify = function (f) { return function (sa) {
    var g = exports.prismModifyOption(f)(sa);
    return function (s) {
        return pipeable_1.pipe(g(s), O.getOrElse(function () { return s; }));
    };
}; };
exports.prismModify = prismModify;
/** @internal */
var prismSet = function (a) { return exports.prismModify(function () { return a; }); };
exports.prismSet = prismSet;
/** @internal */
var prismComposeLens = function (ab) { return function (sa) {
    return exports.optionalComposeOptional(exports.lensAsOptional(ab))(exports.prismAsOptional(sa));
}; };
exports.prismComposeLens = prismComposeLens;
/** @internal */
var prismFromNullable = function () { return ({
    getOption: O.fromNullable,
    reverseGet: function_1.identity
}); };
exports.prismFromNullable = prismFromNullable;
/** @internal */
function prismFromPredicate(predicate) {
    return {
        getOption: O.fromPredicate(predicate),
        reverseGet: function_1.identity
    };
}
exports.prismFromPredicate = prismFromPredicate;
/** @internal */
var prismSome = function () { return ({
    getOption: function_1.identity,
    reverseGet: O.some
}); };
exports.prismSome = prismSome;
/** @internal */
var prismRight = function () { return ({
    getOption: O.fromEither,
    reverseGet: E.right
}); };
exports.prismRight = prismRight;
/** @internal */
var prismLeft = function () { return ({
    getOption: function (s) { return (E.isLeft(s) ? O.some(s.left) : O.none); },
    reverseGet: E.left
}); };
exports.prismLeft = prismLeft;
// -------------------------------------------------------------------------------------
// Optional
// -------------------------------------------------------------------------------------
/** @internal */
var optionalAsTraversal = function (sa) { return ({
    modifyF: function (F) { return function (f) { return function (s) {
        return pipeable_1.pipe(sa.getOption(s), O.fold(function () { return F.of(s); }, function (a) { return F.map(f(a), function (a) { return sa.set(a)(s); }); }));
    }; }; }
}); };
exports.optionalAsTraversal = optionalAsTraversal;
/** @internal */
var optionalModifyOption = function (f) { return function (optional) { return function (s) {
    return pipeable_1.pipe(optional.getOption(s), O.map(function (a) {
        var n = f(a);
        return n === a ? s : optional.set(n)(s);
    }));
}; }; };
exports.optionalModifyOption = optionalModifyOption;
/** @internal */
var optionalModify = function (f) { return function (optional) {
    var g = exports.optionalModifyOption(f)(optional);
    return function (s) {
        return pipeable_1.pipe(g(s), O.getOrElse(function () { return s; }));
    };
}; };
exports.optionalModify = optionalModify;
/** @internal */
var optionalComposeOptional = function (ab) { return function (sa) { return ({
    getOption: function_1.flow(sa.getOption, O.chain(ab.getOption)),
    set: function (b) { return exports.optionalModify(ab.set(b))(sa); }
}); }; };
exports.optionalComposeOptional = optionalComposeOptional;
var findFirstMutable = function (predicate) { return ({
    getOption: A.findFirst(predicate),
    set: function (a) { return function (s) {
        return pipeable_1.pipe(A.findIndex(predicate)(s), O.fold(function () { return s; }, function (i) { return A.unsafeUpdateAt(i, a, s); }));
    }; }
}); };
/** @internal */
exports.findFirst = findFirstMutable;
// -------------------------------------------------------------------------------------
// Traversal
// -------------------------------------------------------------------------------------
/** @internal */
function traversalComposeTraversal(ab) {
    return function (sa) { return ({
        modifyF: function (F) { return function (f) { return sa.modifyF(F)(ab.modifyF(F)(f)); }; }
    }); };
}
exports.traversalComposeTraversal = traversalComposeTraversal;
/** @internal */
function fromTraversable(T) {
    return function () { return ({
        modifyF: function (F) {
            var traverseF = T.traverse(F);
            return function (f) { return function (s) { return traverseF(s, f); }; };
        }
    }); };
}
exports.fromTraversable = fromTraversable;
// -------------------------------------------------------------------------------------
// Ix
// -------------------------------------------------------------------------------------
function indexMutableArray() {
    return {
        index: function (i) { return ({
            getOption: function (as) { return A.lookup(i, as); },
            set: function (a) { return function (as) {
                return pipeable_1.pipe(A.updateAt(i, a)(as), O.getOrElse(function () { return as; }));
            }; }
        }); }
    };
}
/** @internal */
exports.indexArray = indexMutableArray;
/** @internal */
function indexRecord() {
    return {
        index: function (k) { return ({
            getOption: function (r) { return R.lookup(k, r); },
            set: function (a) { return function (r) {
                if (r[k] === a || O.isNone(R.lookup(k, r))) {
                    return r;
                }
                return R.insertAt(k, a)(r);
            }; }
        }); }
    };
}
exports.indexRecord = indexRecord;
// -------------------------------------------------------------------------------------
// At
// -------------------------------------------------------------------------------------
/** @internal */
function atRecord() {
    return {
        at: function (key) { return ({
            get: function (r) { return R.lookup(key, r); },
            set: O.fold(function () { return R.deleteAt(key); }, function (a) { return R.insertAt(key, a); })
        }); }
    };
}
exports.atRecord = atRecord;
